
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module WiFi_Web_Server(

	//////////// CLOCK //////////
	input 		          		FPGA_CLK1_50,
	input 		          		FPGA_CLK2_50,
	input 		          		FPGA_CLK3_50,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [7:0]		LED,

	//////////// SW //////////
	input 		     [3:0]		SW,

	//////////// GPIO_0, GPIO connect to RFS - RF and Sensor //////////
	inout 		          		BT_KEY,
	input 		          		BT_UART_RX,
	output		          		BT_UART_TX,
	input 		          		LSENSOR_INT,
	inout 		          		LSENSOR_SCL,
	inout 		          		LSENSOR_SDA,
	inout 		          		MPU_AD0_SDO,
	output		          		MPU_CS_n,
	output		          		MPU_FSYNC,
	input 		          		MPU_INT,
	inout 		          		MPU_SCL_SCLK,
	inout 		          		MPU_SDA_SDI,
	input 		          		RH_TEMP_DRDY_n,
	inout 		          		RH_TEMP_I2C_SCL,
	inout 		          		RH_TEMP_I2C_SDA,
	inout 		     [7:0]		TMD_D,
	input 		          		UART2USB_CTS,
	output		          		UART2USB_RTS,
	input 		          		UART2USB_RX,
	output		          		UART2USB_TX,
	output		          		WIFI_EN,
	output		          		WIFI_RST_n,
	input 		          		WIFI_UART0_CTS,
	output		          		WIFI_UART0_RTS,
	input 		          		WIFI_UART0_RX,
	output		          		WIFI_UART0_TX,
	input 		          		WIFI_UART1_RX
);



//=======================================================
//  REG/WIRE declarations
//=======================================================
wire pio_wifi_reset;

//wire HEX0_DP, HEX1_DP, HEX2_DP, HEX3_DP, HEX4_DP, HEX5_DP;

//=======================================================
//  Structural coding
//=======================================================

assign WIFI_RST_n = KEY[0] & pio_wifi_reset;
assign WIFI_EN = 1'b1;

assign LED[6] = ~WIFI_UART0_TX;
assign LED[7] = ~WIFI_UART0_RX;

assign UART2USB_TX = ((SW[0] == 1'b0)? WIFI_UART0_RX: WIFI_UART0_TX);

RFS_WiFi u0(
        .clk_clk(FPGA_CLK1_50),                                         //                                clk.clk
        .reset_reset_n(KEY[0]),                                         //                              reset.reset_n
        .pio_key_external_connection_export(KEY[1]),                    //            key_external_connection.export

        .wifi_uart0_external_connection_rxd(WIFI_UART0_RX),             //     wifi_uart0_external_connection.rxd
        .wifi_uart0_external_connection_txd(WIFI_UART0_TX),             //                                   .txd
        .wifi_uart0_external_connection_cts_n(WIFI_UART0_CTS),          //                                   .cts_n
        .wifi_uart0_external_connection_rts_n(WIFI_UART0_RTS),          //                                   .rts_n

        //.seg7_if_0_conduit_end_export({HEX5, HEX4,
        //                               HEX3, HEX2,
        //                               HEX1, HEX0}),                    //              seg7_if_0_conduit_end.export

        .pio_wifi_reset_external_connection_export(pio_wifi_reset),     // pio_wifi_reset_external_connection.export
        .pio_led_external_connection_export(LED[3: 0])                  //        pio_led_external_connection.export
    );

endmodule
